<%@ Language="VBScript" %>
<%
Option Explicit

'This variable specifies relative path to the folder, where the gallery with uploaded files is located.
'Do not forget about the slash in the end of the folder name.
Dim strGalleryPath
strGalleryPath = "../Gallery/"


Sub ProcessUpload
	'Create Dundas Upload object for upload processing.
	Dim objUpload
	Set objUpload = Server.CreateObject("Dundas.Upload.2")
	objUpload.UseVirtualDir = False
	objUpload.MaxUploadSize = 1000000000
	
	'Fetch first source file to populate Form collection.
	Dim objSourceFile
	Set objSourceFile = objUpload.GetNextFile

	'First of all, clear files and data uploaded at previous time.

	Dim objFolder, objFile

	'Delete source files.
	Set objFolder = objFileSystem.GetFolder(Server.MapPath(strGalleryPath))
	For Each objFile In objFolder.Files
		objFileSystem.DeleteFile objFile.Path, True
	Next

	'Delete thumbnails.
	Set objFolder = objFileSystem.GetFolder(Server.MapPath(strGalleryPath) & "\Thumbnails")
	For Each objFile In objFolder.Files
		objFileSystem.DeleteFile objFile.Path, True
	Next

	'NOTE: If you do not want to delete previously uploaded files, just 
	'remove or comment out the code above.

	'Create XML file which will keep information about files (image dimensions, description, etc). 
	'XML is used solely for brevity. In real-life application most likely you will use database instead.
	Dim objDescriptions
	Set objDescriptions = Server.CreateObject("Msxml2.DOMDocument.4.0")
	objDescriptions.appendChild(objDescriptions.createElement("files"))

	'Get total number of uploaded files (all files are uploaded in a single package).
	Dim intFileCount, i
	intFileCount = CInt(objUpload.Form("FileCount").Value)

	'Iterate through uploaded data and save the original file, thumbnail, and description.
	For i = 1 To intFileCount
		'Get source file and save it to disk.
		If i > 1 Then
			Set objSourceFile = objUpload.GetNextFile
		End If
		Dim strFileName
		strFileName = GetSafeFileName(objUpload.GetFileName(objSourceFile.OriginalPath))		
		objSourceFile.Save Server.MapPath(strGalleryPath)
		objUpload.FileMove Server.MapPath(strGalleryPath & objSourceFile.FileName), _
			Server.MapPath(strGalleryPath & strFileName) 
			
		'Get first thumbnail (the single thumbnail in this code sample) and save it to disk.
		Dim objThumbnail1File
		Set objThumbnail1File = objUpload.GetNextFile
		objThumbnail1File.Save Server.MapPath(strGalleryPath)
		objUpload.FileMove Server.MapPath(strGalleryPath & objThumbnail1File.FileName), _
			Server.MapPath(strGalleryPath & "Thumbnails/" & strFileName & ".jpg")
			
		'Save file info.
		Dim objXmlFile	
		Set objXmlFile = objDescriptions.createElement("file")
		objXmlFile.setAttribute "name", strFileName
		objXmlFile.setAttribute "width", objUpload.Form("Width_" & i).Value
		objXmlFile.setAttribute "height", objUpload.Form("Height_" & i).Value
		If IsEmpty(objUpload.Form("Description_" & i)) Then
			objXmlFile.setAttribute "description", ""
		Else
			objXmlFile.setAttribute "description", objUpload.Form("Description_" & i).Value
		End If
		objDescriptions.documentElement.appendChild objXmlFile
	Next

	objDescriptions.save Server.MapPath(strGalleryPath & "Descriptions.xml")
End Sub

'This method verifies whether file with such name already exists 
'and if so, construct safe filename name (to avoid collision).	
Function GetSafeFileName(strFileName)	
	Dim strNewFileName
	strNewFileName = strFileName
	Dim j 
	j = 1
	While (objFileSystem.FileExists(Server.MapPath(strGalleryPath & strNewFileName)))
		strNewFileName = j & "_" & strFileName
		j = j + 1
	Wend
	GetSafeFileName = strNewFileName
End Function


Dim objFileSystem
Set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")

ProcessUpload
%>