<%@ Page Language="C#" AutoEventWireup="true" EnableViewState="false" Debug="true" %>

<%@ OutputCache Duration="1" VaryByParam="None" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Xml" %>

<script runat="server">
	//This variable specifies relative path to the folder, where the gallery with uploaded files is located.
	//Do not forget about the slash in the end of the folder name.
	string galleryPath = "../Gallery/";

	private void Page_Load(System.Object sender, System.EventArgs e)
	{
		XmlDocument descriptions = new XmlDocument();
		descriptions.Load(Server.MapPath(galleryPath + "Descriptions.xml"));

		DataList1.DataSource = descriptions.DocumentElement.ChildNodes;
		DataList1.DataBind();
	}

	private string EncodeFileName(string value)
	{
		return Server.UrlEncode(value).Replace("+", "%20");
	}
</script>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Aurigma Image Uploader - Uploaded Files</title>
	<link href="style.css" type="text/css" rel="stylesheet" />
</head>
<body>
	<p>
		<a href="default.aspx">Upload New Photos</a>
	</p>
	<asp:DataList ID="DataList1" Width="100%" RepeatLayout="Table" RepeatDirection="Vertical"
		RepeatColumns="4" runat="server">
		<HeaderTemplate>
		</HeaderTemplate>
		<ItemTemplate>
			<a href="<%# galleryPath + EncodeFileName(((XmlElement)(Container.DataItem)).GetAttribute("name")) %>"
				target="_blank">
				<img src="<%# galleryPath + "Thumbnails/" + EncodeFileName(((XmlElement)(Container.DataItem)).GetAttribute("name")) %>.jpg"
					alt="<%# Server.HtmlEncode(((XmlElement)(Container.DataItem)).GetAttribute("name"))%>" />
			</a>
			<br />
			<br />
			<b>Name:</b>
			<%# Server.HtmlEncode(((XmlElement)(Container.DataItem)).GetAttribute("name")) %>
			<br />
			<b>Dimensions:</b>
			<%# Server.HtmlEncode(((XmlElement)(Container.DataItem)).GetAttribute("width")) %>
			x
			<%# Server.HtmlEncode(((XmlElement)(Container.DataItem)).GetAttribute("height")) %>
			<br />
			<b>Formats:</b>
			<%# Server.HtmlEncode(((XmlElement)(Container.DataItem)).GetAttribute("description")) %>
		</ItemTemplate>
		<FooterTemplate>
		</FooterTemplate>
	</asp:DataList>
</body>
</html>
