<%@ Page Language="VB" AutoEventWireup="false" ValidateRequest="false" Debug="true" %>

<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Xml" %>

<script runat="server">
	'This variable specifies relative path to the folder, where the gallery with uploaded files is located.
	'Do not forget about the slash in the end of the folder name.
	Private galleryPath As String = "../Gallery/"

	Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		'First of all, clear data uploaded at previous time.

		'Delete source files
		Dim dir As New DirectoryInfo(Server.MapPath(galleryPath))
		For Each file As FileInfo In dir.GetFiles()
			file.Delete()
		Next

		'Delete thumbnails
		dir = New DirectoryInfo(Server.MapPath(galleryPath) & "/Thumbnails")
		For Each file As FileInfo In dir.GetFiles()
			file.Delete()
		Next
        
		'NOTE: If you do not want to delete previously uploaded files, just 
		'remove or comment out the code above.

		'Create XML file which will keep information about files (image dimensions, description, etc). 
		'XML is used solely for brevity. In real-life application most likely you will use database instead.
		Dim descriptions As New XmlDocument()
		descriptions.AppendChild(descriptions.CreateElement("files"))

		'Get total number of uploaded files (all files are uploaded in a single package).
		Dim fileCount As Integer = Int32.Parse(Request.Form("FileCount"))

		'Get author name from attached HTML form.
		Dim author As String = Request.Form("Author")

		'Iterate through uploaded data and save the original file, thumbnail, and description.
		For i As Integer = 1 To fileCount

			'Get the first thumbnail (watermarked image) and save it to disk.
			Dim thumbnail1File As HttpPostedFile = Request.Files("Thumbnail1_" & i)
			Dim fileName As String = GetSafeFileName(Path.GetFileName(Request.Form("FileName_" & i)))
			thumbnail1File.SaveAs(Server.MapPath(galleryPath & fileName))
			
			'Get the second thumbnail (small thumbnail) and save it to disk.
			Dim thumbnail2File As HttpPostedFile = Request.Files("Thumbnail2_" & i)
			thumbnail2File.SaveAs(Server.MapPath(galleryPath & "Thumbnails/" & fileName & ".jpg"))

			'Save file info.
			Dim xmlFile As XmlElement = descriptions.CreateElement("file")
			xmlFile.SetAttribute("name", fileName)
			xmlFile.SetAttribute("width", Request.Form("Width_" & i))
			xmlFile.SetAttribute("height", Request.Form("Height_" & i))
			xmlFile.SetAttribute("author", author)

			descriptions.DocumentElement.AppendChild(xmlFile)
			
		Next
		
		descriptions.Save(Server.MapPath(galleryPath & "Descriptions.xml"))
	End Sub

	'This method verifies whether file with such name already exists 
	'and if so, construct safe filename name (to avoid collision).	
	Private Function GetSafeFileName(ByVal fileName As String) As String
		
		Dim newFileName As String = fileName
		Dim j As Integer = 1
		While (File.Exists(Server.MapPath(galleryPath & newFileName)))
			newFileName = j & "_" & fileName
			j += 1
		End While
		
		Return newFileName
	
	End Function
</script>

