<%@ page language='java' import='java.io.*,java.util.*,javax.servlet.*,javax.servlet.http.*,org.apache.commons.fileupload.*,org.w3c.dom.*,org.w3c.dom.ls.*'%>
<%!
//This variable specifies relative path to the folder, where the gallery with uploaded files is located.
//Do not forget about the slash in the end of the folder name.
String galleryPath = "/Gallery/";

String absGalleryPath;
String absThumbnailsPath;
String absTempPath;

//This method verifies whether file with such name already exists
//and if so, construct safe filename name (to avoid collision).
String getSafeFileName(String fileName) {
    String newFileName = fileName;
    File file = new File(absGalleryPath + File.separator + newFileName);
    int j = 1;
    while (file.exists()) {
	newFileName = j + "_" + fileName;
	file = new File(absGalleryPath + File.separator + newFileName);
	j = j + 1;
    }
    return newFileName;
}

private void deleteFiles(String path) {
    File dir = new File(path);

    String[] dirList = dir.list();
    for (int i = 0; i < dirList.length; i++) {
	File file = new File(path + File.separator + dirList[i]);
	if (file.isFile()) {
	    file.delete();
	}
    }
}

private void saveXml(Document document, String path) throws IOException {
    DOMImplementation implementation = document.getImplementation();
    DOMImplementationLS implementationLS = (DOMImplementationLS) implementation.getFeature("LS", "3.0");
    LSSerializer serializer = implementationLS.createLSSerializer();
    LSOutput output = implementationLS.createLSOutput();
    FileOutputStream stream = new FileOutputStream(path);
    output.setByteStream(stream);
    serializer.write(document, output);
    stream.close();
}
%>
<%
//Process request.
ServletContext context = getServletContext();
absGalleryPath = context.getRealPath(galleryPath);
absThumbnailsPath = context.getRealPath(galleryPath + "/Thumbnails");
absTempPath = context.getRealPath(galleryPath + "/Temp");

//Process upload.
DiskFileUpload fileUpload = new DiskFileUpload();
//Set maximum size before a FileUploadException will be thrown.
fileUpload.setSizeMax(100000000);
//Set maximum size that will be stored in memory.
fileUpload.setSizeThreshold(4096);
//Set the location for saving data that is larger than getSizeThreshold().
fileUpload.setRepositoryPath(absTempPath);

//Get uploaded files.
List listFileItems = fileUpload.parseRequest(request);

//Put them in hash table for fast access.
Hashtable fileItems = new Hashtable();

for (int i = 0; i < listFileItems.size(); i++) {
    FileItem fileItem = (FileItem)(listFileItems.get(i));
    fileItems.put(fileItem.getFieldName(), fileItem);
}

//First of all, clear data uploaded at previous time.

//In this code sample each file is uploaded with a separate request. It means that this
//page will be called for each file individually (rather than once for all files). Therefore
//we need a way to determine whether this page is called for new upload session or not.
//
//To do it we check a PackageIndex POST field which returns a number of the request in the upload session.
//If it is the very first package we should delete all files and thumbnails we uploaded before.
//Otherwise, previously uploaded files belong to the same upload session and we should not delete them.
int packageIndex = Integer.parseInt(((FileItem) fileItems.get("PackageIndex")).getString());

//If we receive the first file, we delete all files and thumbnails we uploaded before.
if (packageIndex == 0) {
    //Delete source files.
    deleteFiles(absGalleryPath);
    
    //Delete thumbnails.
    deleteFiles(absThumbnailsPath);
}

//NOTE: If you do not want to delete previously uploaded files, just
//remove or comment out the code above.

//Create XML file which will keep information about files (image dimensions, description, etc).
//XML is used solely for brevity. In real-life application most likely you will use database instead.
javax.xml.parsers.DocumentBuilder builder =
	javax.xml.parsers.DocumentBuilderFactory.newInstance().newDocumentBuilder();
org.w3c.dom.Document descriptions;

//If we receive the first file then
//we start from empty file with descriptions
if (packageIndex == 0) {
    descriptions = builder.newDocument();
    descriptions.appendChild(descriptions.createElement("files"));
} else {
    descriptions = builder.parse(absGalleryPath + File.separator + "Descriptions.xml");
}

//NOTE: Since each file is uploaded in a separate request (because
//FilesPerOnePackageCount param equals to 1), you should work only
//with POST fields with index = 1 (such as SourceFile_1, FileName_1, etc).
FileItem sourceFileItem = (FileItem) fileItems.get("SourceFile_1");
String fileName = getSafeFileName(new File(sourceFileItem.getName()).getName());
File sourceFile = new File(absGalleryPath + File.separator + fileName);
sourceFileItem.write(sourceFile);

//Get the thumbnail and save it to disk.
FileItem thumbnail1FileItem = (FileItem) fileItems.get("Thumbnail1_1");
File thumbnail1File = new File(absThumbnailsPath + File.separator + fileName + ".jpg");
thumbnail1FileItem.write(thumbnail1File);

//Save file info.
Element xmlFile = descriptions.createElement("file");
xmlFile.setAttribute("name", fileName);
xmlFile.setAttribute("width", ((FileItem) fileItems.get("Width_1")).getString());
xmlFile.setAttribute("height", ((FileItem) fileItems.get("Height_1")).getString());
descriptions.getDocumentElement().appendChild(xmlFile);

saveXml(descriptions, absGalleryPath + File.separator + "Descriptions.xml");
%>