require 'cgi'
require 'rexml/document'


#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
$galleryPath = "../Gallery/"

def print_html()
	print "Content-Type: text/html\r\n\r\n"
	print "\r\n"
end

def save_uploaded_files()
	$absGalleryPath = File.expand_path($galleryPath)
	absThumbnailsPath = File.join($absGalleryPath, "Thumbnails")

	cgi = CGI.new()

	#Get the source file and save it to disk. 

	#NOTE: Since each file is uploaded in a separate request (because 
	#FilesPerOnePackageCount param equals to 1), you should work only 
	#with POST fields with index = 1 (such as SourceFile_1, FileName_1, etc). 
	sourceFile = cgi.params["SourceFile_1"].first
	fileName = get_safe_file_name(sourceFile.original_filename)
	sourceFileTargetPath = File.join($absGalleryPath, fileName)
	File.open(sourceFileTargetPath.untaint, 'wb') { |file| file << sourceFile.read}

	#Get the thumbnail and save it to disk.
	thumbnail1 = cgi.params["Thumbnail1_1"].first
	thumbnail1TargetPath = File.join(absThumbnailsPath, fileName)
	File.open(thumbnail1TargetPath.untaint, 'wb') { |file| file << thumbnail1.read}

	#Get file info and save it to XML file.
	#NOTE: In this demo this file is used by different upload threads asynchronously. That's why 
	#it is necessary to synchronize access to this file. 
	
	#TODO: Ugly and unsafe style
	
	descriptionsLockPath = File.join($absGalleryPath, "Descriptions.lck")	
	lockf = File.open(descriptionsLockPath, "w")
	lockf.flock(File::LOCK_EX) 
	
	descriptionsPath = File.join($absGalleryPath, "Descriptions.xml")

	#Create XML file which will keep information about files (image dimensions, description, etc). 
	#XML is used solely for brevity. In real-life application most likely you will use database instead.

	if FileTest.exist?(descriptionsPath) then
		file = File.new(descriptionsPath)
		descriptions = REXML::Document.new file
		file.close
		filesElem = REXML::XPath.first(descriptions, "/files")
	else		
		descriptions = REXML::Document.new 
		filesElem = descriptions.add_element("files")
	end

	fileElem = filesElem.add_element "file"
	fileElem.attributes["name"] = fileName
	fileElem.attributes["width"] = cgi.params["Width_1"].first.read
	fileElem.attributes["height"] = cgi.params["Height_1"].first.read
	fileElem.attributes["handlerUrl"] = ENV["SCRIPT_NAME"] + "?" + ENV["QUERY_STRING"]

	File.open(descriptionsPath.untaint, 'w') { |file| descriptions.write file}	

	#Release lock file.
	lockf.close()
end

def get_safe_file_name(fileName)
	newFileName = File.basename(fileName)
	j = 1
	while FileTest.exist?(File.join($absGalleryPath, newFileName))
		newFileName = j.to_s + "_" + fileName
	end
	return newFileName
end

print_html()

save_uploaded_files()