#!/usr/bin/env ruby

require 'cgi'
require 'rexml/document'

#This variable specifies relative path to the folder, where the gallery with uploaded files is located.
#Do not forget about the slash in the end of the folder name.
$galleryPath = "../Gallery/"

rows = ""

HTML_TEMPLATE = <<HTMLEND
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Aurigma Image Uploader - Uploaded Files</title>
	<link href="style.css" type="text/css" rel="stylesheet" />
</head>
<body>
	<p>
		<a href="index.rb">Upload New Files</a>
	</p>
	<table width="100%%">
		%s
	</table>
</body>
</html>
HTMLEND

FILE_INFO_TEMPLATE = <<HTMLEND
<td>
<a href="%s" target="_blank">
<img src="%s" alt="%s" />
</a>
<br />
<br />
<b>Name:</b>
%s
<br />
<b>Dimensions:</b>
%s
x
%s
<br />
<b>Formats:</b>
%s
</td>
HTMLEND

def print_html()
	print "Content-Type: text/html\r\n\r\n"

	file = File.new(File.join(File.expand_path($galleryPath), "Descriptions.xml"))
	descriptions = REXML::Document.new file

	colCount = 4	

	rows = ""

	xmlFiles = REXML::XPath.match(descriptions, "files/file") 

	for i in 0..xmlFiles.length - 1
		if i % colCount == 0 then
			rows << "<tr>"
		end

		xmlFile = xmlFiles[i]

		fileName = xmlFile.attributes["name"]	

		rows << FILE_INFO_TEMPLATE % [$galleryPath + encode_file_name(fileName), \
		$galleryPath + "Thumbnails/" + encode_file_name(fileName), \
		CGI.escapeHTML(fileName), \
		CGI.escapeHTML(fileName), \
		CGI.escapeHTML(xmlFile.attributes["width"]), \
		CGI.escapeHTML(xmlFile.attributes["height"]), \
		CGI.escapeHTML(xmlFile.attributes["description"])]

		if ((i + 1) % colCount == 0) or (i == xmlFiles.length - 1) then
			rows << "</tr>"
		end
	end

	printf HTML_TEMPLATE, rows
end

def encode_file_name(value)
	return CGI.escape(value).gsub(/\+/, "%20")
end

print_html()